From a69b316afe9e86fb423baeb773d6f70629d90fa1 Mon Sep 17 00:00:00 2001
From: Peter Geoghegan <pg@bowt.ie>
Date: Sat, 28 Mar 2020 16:01:37 -0700
Subject: [PATCH v1] Consistently truncate non-key suffix columns.

Oversight in commit dd299df8.
---
 src/backend/access/nbtree/nbtutils.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/src/backend/access/nbtree/nbtutils.c b/src/backend/access/nbtree/nbtutils.c
index 54afa6f417..9395310b59 100644
--- a/src/backend/access/nbtree/nbtutils.c
+++ b/src/backend/access/nbtree/nbtutils.c
@@ -2205,7 +2205,8 @@ _bt_truncate(Relation rel, IndexTuple lastleft, IndexTuple firstright,
 	{
 		IndexTuple	tidpivot;
 
-		pivot = index_truncate_tuple(itupdesc, firstright, keepnatts);
+		pivot = index_truncate_tuple(itupdesc, firstright,
+									 Min(keepnatts, nkeyatts));
 
 		if (BTreeTupleIsPosting(pivot))
 		{
-- 
2.25.1

